﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Puyo_Dani
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        TextBox[] name;
        TextBox[] nowPoint;
        TextBox nowMatch;

        TextBox[] up;
        TextBox[] down;

        TextBox[] reserveName;
        TextBox[] reservePoint;

        TextBox[] awayName;
        TextBox[] awayPoint;

        CheckBox isFirst;

        TextBox result;

        string[][] prename;
        string[][] prenowPoint;
        string[] prenowMatch;

        string[][] preup;
        string[][] predown;

        string[][] prereserveName;
        string[][] prereservePoint;

        string[][] preawayName;
        string[][] preawayPoint;

        string[] preresult;


        static int N = 7;

        int M = 5;
        int R = 4;

        static Random rnd;
        static int movePoint = 3;

        static int S = 100;

        static string filename = "dani_data.dat";
        static Encoding sjisEnc = Encoding.GetEncoding("Shift_JIS");

        CheckBox saveflag;

        private void Form1_Load(object sender, EventArgs e)
        {
            this.FormClosing += new FormClosingEventHandler(Form1_Closing);
            name = new TextBox[N];
            nowPoint = new TextBox[N];
            rnd = new Random();

            name[0] = textBox1;
            name[1] = textBox4;
            name[2] = textBox7;
            name[3] = textBox10;
            name[4] = textBox13;
            name[5] = textBox16;
            name[6] = textBox19;

            nowPoint[0] = textBox2;
            nowPoint[1] = textBox5;
            nowPoint[2] = textBox8;
            nowPoint[3] = textBox11;
            nowPoint[4] = textBox14;
            nowPoint[5] = textBox17;
            nowPoint[6] = textBox20;

            up = new TextBox[M];
            up[0] = textBox12;
            up[1] = textBox9;
            up[2] = textBox6;
            up[3] = textBox3;
            up[4] = textBox41;

            down = new TextBox[M];

            down[0] = textBox24;
            down[1] = textBox21;
            down[2] = textBox18;
            down[3] = textBox15;
            down[4] = textBox42;

            reserveName = new TextBox[M];
            reserveName[0] = textBox34;
            reserveName[1] = textBox32;
            reserveName[2] = textBox30;
            reserveName[3] = textBox27;
            reserveName[4] = textBox43;

            reservePoint = new TextBox[M];
            reservePoint[0] = textBox35;
            reservePoint[1] = textBox33;
            reservePoint[2] = textBox31;
            reservePoint[3] = textBox29;
            reservePoint[4] = textBox44;

            awayName = new TextBox[R];
            awayName[0] = textBox38;
            awayName[1] = textBox36;
            awayName[2] = textBox25;
            awayName[3] = textBox22;

            awayPoint = new TextBox[R];
            awayPoint[0] = textBox39;
            awayPoint[1] = textBox37;
            awayPoint[2] = textBox26;
            awayPoint[3] = textBox23;

            nowMatch = textBox28;

            isFirst = checkBox1;

            result = textBox40;

            saveflag = checkBox2;

            prename = new string[S][];
            prenowPoint = new string[S][];

            preup = new string[S][];
            predown = new string[S][];

            prereserveName = new string[S][];
            prereservePoint = new string[S][];

            preawayName = new string[S][];
            preawayPoint = new string[S][];

            prenowMatch = new string[S];
            preresult = new string[S];

            for (int i = 0; i < S; i++)
            {
                prename[i] = new string[N];
                prenowPoint[i] = new string[N];
                for (int j = 0; j < N; j++)
                {
                    prename[i][j] = "";
                    prenowPoint[i][j] = "";
                }

                preup[i] = new string[M];
                predown[i] = new string[M];

                prereserveName[i] = new string[M];
                prereservePoint[i] = new string[M];


                for (int j = 0; j < M; j++)
                {
                    preup[i][j] = "";
                    predown[i][j] = "";
                    prereserveName[i][j] = "";
                    prereservePoint[i][j] = "";
                }

                preawayName[i] = new string[R];
                preawayPoint[i] = new string[R];

                for (int j = 0; j < R; j++)
                {
                    preawayName[i][j] = "";
                    preawayPoint[i][j] = "";
                }

                prenowMatch[i] = "";
                preresult[i] = "";
            }
            preresult[0] = "myon";
        }

        private void button5_Click(object sender, EventArgs e)
        {
            update();
            matchAdd(-1);
            autosave();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            update();
            matchAdd(1);
            autosave();
        }

        void matchAdd(int a)
        {
            try
            {
                nowMatch.Text = (int.Parse(nowMatch.Text) + a).ToString();
            }
            catch { }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            update();
            sort();
            autosave();
        }

        void sort()
        {
            try
            {
                bool flag = true;
                while (flag)
                {
                    flag = false;
                    int pre = -1;
                    for (int i = 0; i < N; i++)
                    {
                        if (isEmpty(i))
                        {
                            pre = i;
                            break;
                        }
                    }
                    for (int i = pre + 1; i < N; i++)
                    {
                        if (!isEmpty(i))
                        {
                            flag = true;
                            name[pre].Text = name[i].Text;
                            nowPoint[pre].Text = nowPoint[i].Text;
                            name[i].Text = "";
                            nowPoint[i].Text = "";
                            break;
                        }
                    }
                }
            }
            catch { }
        }

        private bool isEmpty(int a)
        {
            return name[a].Text == "" && nowPoint[a].Text == "";
        }

        private void button8_Click(object sender, EventArgs e)
        {
            try
            {
                update();
                matchAdd(1);
                addp(0);
                decp(1);
                int i = 1;
                int pre = N - 1;
                name[pre].Text = name[i].Text;
                nowPoint[pre].Text = nowPoint[i].Text;
                name[i].Text = "";
                nowPoint[i].Text = "";
                sort();
                autosave();
            }
            catch { }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            try
            {
                update();
                matchAdd(1);
                addp(1);
                decp(0);
                int i = 0;
                int pre = N - 1;
                name[pre].Text = name[i].Text;
                nowPoint[pre].Text = nowPoint[i].Text;
                name[i].Text = "";
                nowPoint[i].Text = "";
                sort();
                autosave();
            }
            catch { }
        }

        private void button11_Click(object sender, EventArgs e)
        {
            update();
            addp(2);
            autosave();
        }

        void addp(int a)
        {
            try
            {
                nowPoint[a].Text = (int.Parse(nowPoint[a].Text) + 1).ToString();
                if (int.Parse(nowPoint[a].Text) >= movePoint)
                {
                    pushUp(a);
                }

            }
            catch { }
        }

        void decp(int a)
        {
            try
            {
                nowPoint[a].Text = (int.Parse(nowPoint[a].Text) - 1).ToString();
                if (isFirst.Checked)
                {
                    if (int.Parse(nowPoint[a].Text) < 0)
                    {
                        nowPoint[a].Text = "0";
                    }
                }
                if (int.Parse(nowPoint[a].Text) <= -movePoint)
                {
                    pushDown(a);
                }
            }
            catch { }
        }

        void pushUp(int a)
        {
            if (name[a].Text == "") return;
            for (int i = M - 2; i >= 0; i--)
            {
                up[i + 1].Text = up[i].Text;
                up[i].Text = "";
            }
            up[0].Text = name[a].Text;
            name[a].Text = "";
            nowPoint[a].Text = "";
        }

        void pushDown(int a)
        {
            if (name[a].Text == "") return;
            for (int i = M - 2; i >= 0; i--)
            {
                down[i + 1].Text = down[i].Text;
                down[i].Text = "";
            }
            down[0].Text = name[a].Text;
            name[a].Text = "";
            nowPoint[a].Text = "";
        }

        void pushReserve(int a)
        {
            if (name[a].Text == "") return;
            for (int i = M - 2; i >= 0; i--)
            {
                reserveName[i + 1].Text = reserveName[i].Text;
                reserveName[i].Text = "";
                reservePoint[i + 1].Text = reservePoint[i].Text;
                reservePoint[i].Text = "";
            }
            reserveName[0].Text = name[a].Text;
            reservePoint[0].Text = nowPoint[a].Text;
            name[a].Text = "";
            nowPoint[a].Text = "";
            sort();
        }

        void pushAway(int a)
        {
            if (name[a].Text == "") return;
            for (int i = R - 2; i >= 0; i--)
            {
                awayName[i + 1].Text = awayName[i].Text;
                awayName[i].Text = "";
                awayPoint[i + 1].Text = awayPoint[i].Text;
                awayPoint[i].Text = "";
            }
            awayName[0].Text = name[a].Text;
            awayPoint[0].Text = nowPoint[a].Text;
            name[a].Text = "";
            nowPoint[a].Text = "";
            sort();
        }

        void popUp()
        {
            name[N - 1].Text = up[0].Text;
            nowPoint[N - 1].Text = "2";
            sort();
            for (int i = 0; i < M - 1; i++)
            {
                up[i].Text = up[i + 1].Text;
                up[i + 1].Text = "";
            }
        }

        void popDown()
        {
            name[N - 1].Text = down[0].Text;
            nowPoint[N - 1].Text = "-2";
            sort();
            for (int i = 0; i < M - 1; i++)
            {
                down[i].Text = down[i + 1].Text;
                down[i + 1].Text = "";
            }
        }

        void popReserve()
        {
            if (reserveName[0].Text == "") return;
            name[N - 1].Text = reserveName[0].Text;
            nowPoint[N - 1].Text = reservePoint[0].Text;
            sort();
            for (int i = 0; i < M - 1; i++)
            {
                reserveName[i].Text = reserveName[i + 1].Text;
                reserveName[i + 1].Text = "";
                reservePoint[i].Text = reservePoint[i + 1].Text;
                reservePoint[i + 1].Text = "";
            }
        }

        void popAway()
        {
            if (awayName[0].Text == "") return;
            name[N - 1].Text = awayName[0].Text;
            nowPoint[N - 1].Text = awayPoint[0].Text;
            sort();
            for (int i = 0; i < R - 1; i++)
            {
                awayName[i].Text = awayName[i + 1].Text;
                awayName[i + 1].Text = "";
                awayPoint[i].Text = awayPoint[i + 1].Text;
                awayPoint[i + 1].Text = "";
            }
        }

        private void button21_Click(object sender, EventArgs e)
        {
            update();
            pushAway(0);
            autosave();
        }

        private void button22_Click(object sender, EventArgs e)
        {
            update();
            pushAway(1);
            autosave();
        }

        private void button26_Click(object sender, EventArgs e)
        {
            update();
            pushAway(2);
            autosave();
        }

        private void button27_Click(object sender, EventArgs e)
        {
            update();
            pushAway(3);
            autosave();
        }

        private void button28_Click(object sender, EventArgs e)
        {
            update();
            pushAway(4);
            autosave();
        }

        private void button29_Click(object sender, EventArgs e)
        {
            update();
            pushAway(5);
            autosave();
        }

        private void button30_Click(object sender, EventArgs e)
        {
            update();
            pushAway(6);
            autosave();
        }

        private void button34_Click(object sender, EventArgs e)
        {
            update();
            popUp();
            autosave();
        }

        private void button35_Click(object sender, EventArgs e)
        {
            update();
            popDown();
            autosave();
        }

        private void button36_Click(object sender, EventArgs e)
        {
            update();
            popReserve();
            autosave();
        }

        private void button20_Click(object sender, EventArgs e)
        {
            update();
            popAway();
            autosave();
        }

        private void button24_Click(object sender, EventArgs e)
        {
            update();
            for (int i = N - 1; i >= 1; i--)
            {
                name[i].Text = name[i - 1].Text;
                name[i - 1].Text = "";
                nowPoint[i].Text = nowPoint[i - 1].Text;
                nowPoint[i - 1].Text = "";
            }
            for (int i = N - 1; i >= 1; i--)
            {
                if (!isEmpty(i))
                {
                    name[0].Text = name[i].Text;
                    name[i].Text = "";
                    nowPoint[0].Text = nowPoint[i].Text;
                    nowPoint[i].Text = "";
                    break;
                }
            }
            autosave();
        }

        private void button25_Click(object sender, EventArgs e)
        {
            update();
            for (int i = N - 1; i >= 2; i--)
            {
                name[i].Text = name[i - 1].Text;
                name[i - 1].Text = "";
                nowPoint[i].Text = nowPoint[i - 1].Text;
                nowPoint[i - 1].Text = "";
            }
            for (int i = N - 1; i >= 2; i--)
            {
                if (!isEmpty(i))
                {
                    name[1].Text = name[i].Text;
                    name[i].Text = "";
                    nowPoint[1].Text = nowPoint[i].Text;
                    nowPoint[i].Text = "";
                    break;
                }
            }
            autosave();
        }

        private void button33_Click(object sender, EventArgs e)
        {
            update();
            for (int i = 0; i < N - 1; i++)
            {
                int j = rnd.Next(N - i) + i;
                string temp;
                temp = name[i].Text;
                name[i].Text = name[j].Text;
                name[j].Text = temp;

                temp = nowPoint[i].Text;
                nowPoint[i].Text = nowPoint[j].Text;
                nowPoint[j].Text = temp;
            }
            sort();
            autosave();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            update();

            for (int i = 0; i < N; i++)
            {
                name[i].Text = "";
                nowPoint[i].Text = "";
            }
            for (int i = 0; i < M; i++)
            {
                up[i].Text = "";
                down[i].Text = "";
                reserveName[i].Text = "";
                reservePoint[i].Text = "";
            }
            for (int i = 0; i < R; i++)
            {
                awayName[i].Text = "";
                awayPoint[i].Text = "";
            }
            autosave();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            back();
            autosave();
        }

        void update()
        {
            try
            {
                for (int i = S - 1; i >= 1; i--)
                {
                    for (int j = 0; j < N; j++)
                    {
                        prename[i][j] = prename[i - 1][j];
                        prenowPoint[i][j] = prenowPoint[i - 1][j];
                    }

                    for (int j = 0; j < M; j++)
                    {
                        preup[i][j] = preup[i - 1][j];
                        predown[i][j] = predown[i - 1][j];
                        prereserveName[i][j] = prereserveName[i - 1][j];
                        prereservePoint[i][j] = prereservePoint[i - 1][j];
                    }

                    for (int j = 0; j < R; j++)
                    {
                        preawayName[i][j] = preawayName[i - 1][j];
                        preawayPoint[i][j] = preawayPoint[i - 1][j];
                    }

                    prenowMatch[i] = prenowMatch[i - 1];
                    preresult[i] = preresult[i - 1];
                }


                for (int j = 0; j < N; j++)
                {
                    prename[0][j] = name[j].Text;
                    prenowPoint[0][j] = nowPoint[j].Text;
                }

                for (int j = 0; j < M; j++)
                {
                    preup[0][j] = up[j].Text;
                    predown[0][j] = down[j].Text;
                    prereserveName[0][j] = reserveName[j].Text;
                    prereservePoint[0][j] = reservePoint[j].Text;
                }

                for (int j = 0; j < R; j++)
                {
                    preawayName[0][j] = awayName[j].Text;
                    preawayPoint[0][j] = awayPoint[j].Text;
                }

                prenowMatch[0] = nowMatch.Text;
                preresult[0] = result.Text;
            }
            catch { }
        }

        void back()
        {
            try
            {
                if (preresult[0] == "myon") return;

                for (int j = 0; j < N; j++)
                {
                    name[j].Text = prename[0][j];
                    nowPoint[j].Text = prenowPoint[0][j];
                }

                for (int j = 0; j < M; j++)
                {
                    up[j].Text = preup[0][j];
                    down[j].Text = predown[0][j];
                    reserveName[j].Text = prereserveName[0][j];
                    reservePoint[j].Text = prereservePoint[0][j];
                }

                for (int j = 0; j < R; j++)
                {
                    awayName[j].Text = preawayName[0][j];
                    awayPoint[j].Text = preawayPoint[0][j];
                }

                nowMatch.Text = prenowMatch[0];
                result.Text = preresult[0];

                for (int i = 0; i < S - 1; i++)
                {
                    for (int j = 0; j < N; j++)
                    {
                        prename[i][j] = prename[i + 1][j];
                        prenowPoint[i][j] = prenowPoint[i + 1][j];
                    }

                    for (int j = 0; j < M; j++)
                    {
                        preup[i][j] = preup[i + 1][j];
                        predown[i][j] = predown[i + 1][j];
                        prereserveName[i][j] = prereserveName[i + 1][j];
                        prereservePoint[i][j] = prereservePoint[i + 1][j];
                    }

                    for (int j = 0; j < R; j++)
                    {
                        preawayName[i][j] = preawayName[i + 1][j];
                        preawayPoint[i][j] = preawayPoint[i + 1][j];
                    }

                    prenowMatch[i] = prenowMatch[i + 1];
                    preresult[i] = preresult[i + 1];
                }
            }
            catch { }
        }

        private void button42_Click(object sender, EventArgs e)
        {
            string st = "";
            for (int i = 0; i < N; i++)
            {
                if (name[i].Text != "")
                {
                    st += name[i].Text + " " + nowPoint[i].Text + " ";
                }
            }
            for (int i = 0; i < M; i++)
            {
                if (up[i].Text != "")
                {
                    st += up[i].Text + " " + 3 + " ";
                }
            }

            for (int i = 0; i < M; i++)
            {
                if (down[i].Text != "")
                {
                    st += down[i].Text + " " + -3 + " ";
                }
            }


            for (int i = 0; i < R; i++)
            {
                if (awayName[i].Text != "")
                {
                    st += awayName[i].Text + " " + awayPoint[i].Text + " ";
                }
            }
            result.Text = st;
        }

        private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (MessageBox.Show(
              "終了してもよろしいですか？\n 結果の記入をしてから終了してください！\n (終了すると、今のデータは失われます。)", "確認",
              MessageBoxButtons.YesNo, MessageBoxIcon.Question
                ) == DialogResult.No)
            {
                e.Cancel = true;
            }
            else
            {
                if (MessageBox.Show(
              "結果の保存を行いますか？", "確認",
              MessageBoxButtons.YesNo, MessageBoxIcon.Question
                ) == DialogResult.Yes)
                {
                    save();
                }
            }
        }


        string sp = "*|*";
        string sp2 = "$|$";
        string sp3 = "&|&";

        void save()
        {
            try
            {
                string sactive = "";
                string sup = "";
                string sdown = "";
                string sreserve = "";
                string saway = "";
                for (int i = 0; i < N; i++)
                {
                    sactive += name[i].Text;
                    sactive += sp3;
                    sactive += nowPoint[i].Text;
                    sactive += sp2;
                }

                for (int i = 0; i < M; i++)
                {
                    sup += up[i].Text;
                    sup += sp2;
                }

                for (int i = 0; i < M; i++)
                {
                    sdown += down[i].Text;
                    sdown += sp2;
                }

                for (int i = 0; i < M; i++)
                {
                    sreserve += reserveName[i].Text;
                    sreserve += sp3;
                    sreserve += reservePoint[i].Text;
                    sreserve += sp2;
                }

                for (int i = 0; i < R; i++)
                {
                    saway += awayName[i].Text;
                    saway += sp3;
                    saway += awayPoint[i].Text;
                    saway += sp2;
                }

                string st = sactive + sp + sup + sp + sdown + sp + sreserve + sp + saway;
                File.WriteAllText(filename, st, sjisEnc);
            }
            catch
            {
                result.Text = "セーブに失敗したかもです。";
            }
        }

        void load()
        {
            try
            {
                string input = File.ReadAllText(filename, sjisEnc);
                string[] st = input.Split(new string[] { sp }, StringSplitOptions.None);
                string[] sactive = st[0].Split(new string[] { sp2 }, StringSplitOptions.None);
                string[] sup = st[1].Split(new string[] { sp2 }, StringSplitOptions.None);
                string[] sdown = st[2].Split(new string[] { sp2 }, StringSplitOptions.None);
                string[] sreserve = st[3].Split(new string[] { sp2 }, StringSplitOptions.None);
                string[] saway = st[4].Split(new string[] { sp2 }, StringSplitOptions.None);

                for (int i = 0; i < N; i++)
                {
                    string[] st2 = sactive[i].Split(new string[] { sp3 }, StringSplitOptions.None);
                    name[i].Text = st2[0];
                    nowPoint[i].Text = st2[1];
                }

                for (int i = 0; i < M; i++)
                {
                    string[] st2 = sup[i].Split(new string[] { sp3 }, StringSplitOptions.None);
                    up[i].Text = st2[0];
                }

                for (int i = 0; i < M; i++)
                {
                    string[] st2 = sdown[i].Split(new string[] { sp3 }, StringSplitOptions.None);
                    down[i].Text = st2[0];
                }

                for (int i = 0; i < M; i++)
                {
                    string[] st2 = sreserve[i].Split(new string[] { sp3 }, StringSplitOptions.None);
                    reserveName[i].Text = st2[0];
                    reservePoint[i].Text = st2[1];
                }

                for (int i = 0; i < R; i++)
                {
                    string[] st2 = saway[i].Split(new string[] { sp3 }, StringSplitOptions.None);
                    awayName[i].Text = st2[0];
                    awayPoint[i].Text = st2[1];
                }

            }
            catch
            {
                result.Text = "ロードに失敗したかもです。";
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            save();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            load();
        }

        void autosave()
        {
            if (saveflag.Checked)
            {
                save();
            }
        }
        
    }
}
